/*
 * $QNXLicenseC:
 * Copyright 2016, QNX Software Systems.
 * Copyright 2016, Freescale Semiconductor, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"). You
 * may not reproduce, modify or distribute this software except in
 * compliance with the License. You may obtain a copy of the License
 * at: http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as
 * contributors under the License or as licensors under other terms.
 * Please review this entire file for other proprietary rights or license
 * notices, as well as the QNX Development Suite License Guide at
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */

#include "ipl.h"
#include "ipl_mx6x.h"
#include <hw/inout.h>

/**
 * Initialize DDR RAM memory.
 */
void init_sdram(void)
{
	/* Device Configuration Data */
	out32(MX6X_IOMUXC_BASE + 0x5a8, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x5b0, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x524, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x51c, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x518, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x50c, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x5b8, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x5c0, 0x00000030);

	out32(MX6X_IOMUXC_BASE + 0x784, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x788, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x794, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x79c, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x7a0, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x7a4, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x7a8, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x748, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x74c, 0x00000030);
	out32(MX6X_IOMUXC_BASE + 0x78c, 0x00000030);

	out32(MX6X_IOMUXC_BASE + 0x5ac, 0x00020030);
	out32(MX6X_IOMUXC_BASE + 0x5b4, 0x00020030);
	out32(MX6X_IOMUXC_BASE + 0x528, 0x00020030);
	out32(MX6X_IOMUXC_BASE + 0x520, 0x00020030);
	out32(MX6X_IOMUXC_BASE + 0x514, 0x00020030);
	out32(MX6X_IOMUXC_BASE + 0x510, 0x00020030);
	out32(MX6X_IOMUXC_BASE + 0x5bc, 0x00020030);
	out32(MX6X_IOMUXC_BASE + 0x5c4, 0x00020030);

	out32(MX6X_IOMUXC_BASE + 0x56c, 0x00020030);
	out32(MX6X_IOMUXC_BASE + 0x578, 0x00020030);
	out32(MX6X_IOMUXC_BASE + 0x588, 0x00020030);
	out32(MX6X_IOMUXC_BASE + 0x594, 0x00020030);

	out32(MX6X_IOMUXC_BASE + 0x57c, 0x00020030);
	out32(MX6X_IOMUXC_BASE + 0x590, 0x00003000);
	out32(MX6X_IOMUXC_BASE + 0x598, 0x00003000);

	out32(MX6X_IOMUXC_BASE + 0x59c, 0x00003030);
	out32(MX6X_IOMUXC_BASE + 0x5a0, 0x00003030);

	out32(MX6X_IOMUXC_BASE + 0x750, 0x00020000);
	out32(MX6X_IOMUXC_BASE + 0x774, 0x00020000);
	out32(MX6X_IOMUXC_BASE + 0x58c, 0x00000000);
	out32(MX6X_IOMUXC_BASE + 0x758, 0x00000000);
	out32(MX6X_IOMUXC_BASE + 0x798, 0x000C0000);

	out32(MX6X_MMDC_P0_BASE + 0x81c, 0x33333333);
	out32(MX6X_MMDC_P0_BASE + 0x820, 0x33333333);
	out32(MX6X_MMDC_P0_BASE + 0x824, 0x33333333);
	out32(MX6X_MMDC_P0_BASE + 0x828, 0x33333333);
	out32(MX6X_MMDC_P1_BASE + 0x81c, 0x33333333);
	out32(MX6X_MMDC_P1_BASE + 0x820, 0x33333333);
	out32(MX6X_MMDC_P1_BASE + 0x824, 0x33333333);
	out32(MX6X_MMDC_P1_BASE + 0x828, 0x33333333);

	out32(MX6X_MMDC_P0_BASE + 0x018, 0x00011740);

	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00008000);

#if (MX6X_SDRAM_SIZE == 1024)
	/* 1066mhz 4x128mx16 */
	out32(MX6X_MMDC_P0_BASE + 0x004, 0x00020036);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00008000);
	out32(MX6X_MMDC_P0_BASE + 0x00c, 0x555A7974);
	out32(MX6X_MMDC_P0_BASE + 0x010, 0xDB538F64);
	out32(MX6X_MMDC_P0_BASE + 0x014, 0x01FF00DB);
	out32(MX6X_MMDC_P0_BASE + 0x02c, 0x000026D2);
	out32(MX6X_MMDC_P0_BASE + 0x030, 0x005A1023);
	out32(MX6X_MMDC_P0_BASE + 0x008, 0x09444040);
	out32(MX6X_MMDC_P0_BASE + 0x004, 0x00025576);
	out32(MX6X_MMDC_P0_BASE + 0x040, 0x00000027);
	out32(MX6X_MMDC_P0_BASE + 0x000, 0x831A0000);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x04088032);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00008033);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00428031);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x19308030);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x04008040);
	out32(MX6X_MMDC_P0_BASE + 0x800, 0xA1390003);
	out32(MX6X_MMDC_P1_BASE + 0x800, 0xA1390003);
	out32(MX6X_MMDC_P0_BASE + 0x020, 0x00005800);
	out32(MX6X_MMDC_P0_BASE + 0x818, 0x00022227);
	out32(MX6X_MMDC_P1_BASE + 0x818, 0x00022227);
#ifndef NITROGEN6_SOM2
	/* Nitrogen6x / SabreLite */
	out32(MX6X_MMDC_P0_BASE + 0x83c, 0x42720306);
	out32(MX6X_MMDC_P0_BASE + 0x840, 0x026F0266);
	out32(MX6X_MMDC_P1_BASE + 0x83c, 0x4273030A);
	out32(MX6X_MMDC_P1_BASE + 0x840, 0x02740240);
	out32(MX6X_MMDC_P0_BASE + 0x848, 0x45393B3E);
	out32(MX6X_MMDC_P1_BASE + 0x848, 0x403A3747);
	out32(MX6X_MMDC_P0_BASE + 0x850, 0x40434541);
	out32(MX6X_MMDC_P1_BASE + 0x850, 0x473E4A3B);
	out32(MX6X_MMDC_P0_BASE + 0x80c, 0x0011000E);
	out32(MX6X_MMDC_P0_BASE + 0x810, 0x000E001B);
	out32(MX6X_MMDC_P1_BASE + 0x80c, 0x00190015);
	out32(MX6X_MMDC_P1_BASE + 0x810, 0x00070018);
#else
	/* Nitrogen6_SOM2 */
	out32(MX6X_MMDC_P0_BASE + 0x83c, 0x43110320);
	out32(MX6X_MMDC_P0_BASE + 0x840, 0x03080304);
	out32(MX6X_MMDC_P1_BASE + 0x83c, 0x43160324);
	out32(MX6X_MMDC_P1_BASE + 0x840, 0x030d0252);
	out32(MX6X_MMDC_P0_BASE + 0x848, 0x3d343943);
	out32(MX6X_MMDC_P1_BASE + 0x848, 0x3c3b3541);
	out32(MX6X_MMDC_P0_BASE + 0x850, 0x39394134);
	out32(MX6X_MMDC_P1_BASE + 0x850, 0x4332453e);
	out32(MX6X_MMDC_P0_BASE + 0x80c, 0x000e001a);
	out32(MX6X_MMDC_P0_BASE + 0x810, 0x001b0012);
	out32(MX6X_MMDC_P1_BASE + 0x80c, 0x000b001c);
	out32(MX6X_MMDC_P1_BASE + 0x810, 0x000b0017);
#endif
	out32(MX6X_MMDC_P0_BASE + 0x8b8, 0x00000800);
	out32(MX6X_MMDC_P1_BASE + 0x8b8, 0x00000800);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00000000);
	out32(MX6X_MMDC_P0_BASE + 0x404, 0x00011006);

#elif (MX6X_SDRAM_SIZE == 2048)
	/* 1066mhz 4x256mx16 */
	out32(MX6X_MMDC_P0_BASE + 0x004, 0x00020036);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00008000);
	out32(MX6X_MMDC_P0_BASE + 0x00c, 0x898E7974);
	out32(MX6X_MMDC_P0_BASE + 0x010, 0xDB538F64);
	out32(MX6X_MMDC_P0_BASE + 0x014, 0x01FF00DB);
	out32(MX6X_MMDC_P0_BASE + 0x02c, 0x000026D2);
	out32(MX6X_MMDC_P0_BASE + 0x030, 0x008E1023);
	out32(MX6X_MMDC_P0_BASE + 0x008, 0x09444040);
	out32(MX6X_MMDC_P0_BASE + 0x004, 0x00025576);
	out32(MX6X_MMDC_P0_BASE + 0x040, 0x00000047);
	out32(MX6X_MMDC_P0_BASE + 0x000, 0x841A0000);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x04088032);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00008033);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00428031);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x19308030);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x04008040);
	out32(MX6X_MMDC_P0_BASE + 0x800, 0xA1390003);
	out32(MX6X_MMDC_P1_BASE + 0x800, 0xA1390003);
	out32(MX6X_MMDC_P0_BASE + 0x020, 0x00007800);
	out32(MX6X_MMDC_P0_BASE + 0x818, 0x00022227);
	out32(MX6X_MMDC_P1_BASE + 0x818, 0x00022227);
#ifndef NITROGEN6_SOM2
	/* Nitrogen6x / SabreLite */
	out32(MX6X_MMDC_P0_BASE + 0x83c, 0x42740304);
	out32(MX6X_MMDC_P0_BASE + 0x840, 0x026e0265);
	out32(MX6X_MMDC_P1_BASE + 0x83c, 0x02750306);
	out32(MX6X_MMDC_P1_BASE + 0x840, 0x02720244);
	out32(MX6X_MMDC_P0_BASE + 0x848, 0x463d4041);
	out32(MX6X_MMDC_P1_BASE + 0x848, 0x42413c47);
	out32(MX6X_MMDC_P0_BASE + 0x850, 0x37414441);
	out32(MX6X_MMDC_P1_BASE + 0x850, 0x4633473b);
	out32(MX6X_MMDC_P0_BASE + 0x80c, 0x0025001f);
	out32(MX6X_MMDC_P0_BASE + 0x810, 0x00290027);
	out32(MX6X_MMDC_P1_BASE + 0x80c, 0x001f002b);
	out32(MX6X_MMDC_P1_BASE + 0x810, 0x000f0029);
#else
	/* Nitrogen6_SOM2 */
	out32(MX6X_MMDC_P0_BASE + 0x83c, 0x42740304);
	out32(MX6X_MMDC_P0_BASE + 0x840, 0x026e0265);
	out32(MX6X_MMDC_P1_BASE + 0x83c, 0x02750306);
	out32(MX6X_MMDC_P1_BASE + 0x840, 0x02720244);
	out32(MX6X_MMDC_P0_BASE + 0x848, 0x463d4041);
	out32(MX6X_MMDC_P1_BASE + 0x848, 0x42413c47);
	out32(MX6X_MMDC_P0_BASE + 0x850, 0x37414441);
	out32(MX6X_MMDC_P1_BASE + 0x850, 0x4633473b);
	out32(MX6X_MMDC_P0_BASE + 0x80c, 0x0025001f);
	out32(MX6X_MMDC_P0_BASE + 0x810, 0x00290027);
	out32(MX6X_MMDC_P1_BASE + 0x80c, 0x001f002b);
	out32(MX6X_MMDC_P1_BASE + 0x810, 0x000f0029);
#endif
	out32(MX6X_MMDC_P0_BASE + 0x8b8, 0x00000800);
	out32(MX6X_MMDC_P1_BASE + 0x8b8, 0x00000800);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00000000);
	out32(MX6X_MMDC_P0_BASE + 0x404, 0x00011006);

#elif (MX6X_SDRAM_SIZE == 3840) || (MX6X_SDRAM_SIZE == 4096)
	/* 1066mhz 4x512mx16 */
	out32(MX6X_MMDC_P0_BASE + 0x004, 0x00020036);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00008000);
	out32(MX6X_MMDC_P0_BASE + 0x00c, 0x898E79a4);
	out32(MX6X_MMDC_P0_BASE + 0x010, 0xDB538F64);
	out32(MX6X_MMDC_P0_BASE + 0x014, 0x01FF00DD);
	out32(MX6X_MMDC_P0_BASE + 0x02c, 0x0f9f26d2);
	out32(MX6X_MMDC_P0_BASE + 0x030, 0x008E1023);
	out32(MX6X_MMDC_P0_BASE + 0x008, 0x09444040);
	out32(MX6X_MMDC_P0_BASE + 0x004, 0x00025576);
	out32(MX6X_MMDC_P0_BASE + 0x040, 0x00000047);
	out32(MX6X_MMDC_P0_BASE + 0x000, 0xC41A0000);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x04088032);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x0408803a);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00008033);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x0000803b);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00428031);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00428039);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x19308030);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x19308038);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x04008040);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x04008048);
	out32(MX6X_MMDC_P0_BASE + 0x800, 0xA1390003);
	out32(MX6X_MMDC_P1_BASE + 0x800, 0xA1390003);
	out32(MX6X_MMDC_P0_BASE + 0x020, 0x00007800);
	out32(MX6X_MMDC_P0_BASE + 0x818, 0x00022227);
	out32(MX6X_MMDC_P1_BASE + 0x818, 0x00022227);
#ifndef NITROGEN6_SOM2
	/* Nitrogen6x / SabreLite */
#error 4GB version of Nitrogen6x/SabreLite doesn't exist
#else
	/* Nitrogen6_SOM2 */
	out32(MX6X_MMDC_P0_BASE + 0x83c, 0x43200336);
	out32(MX6X_MMDC_P0_BASE + 0x840, 0x03200315);
	out32(MX6X_MMDC_P1_BASE + 0x83c, 0x432a033d);
	out32(MX6X_MMDC_P1_BASE + 0x840, 0x032a026e);
	out32(MX6X_MMDC_P0_BASE + 0x848, 0x42363c48);
	out32(MX6X_MMDC_P1_BASE + 0x848, 0x403b3446);
	out32(MX6X_MMDC_P0_BASE + 0x850, 0x3d3f4737);
	out32(MX6X_MMDC_P1_BASE + 0x850, 0x4436493d);
	out32(MX6X_MMDC_P0_BASE + 0x80c, 0x000c0013);
	out32(MX6X_MMDC_P0_BASE + 0x810, 0x00160012);
	out32(MX6X_MMDC_P1_BASE + 0x80c, 0x000c0017);
	out32(MX6X_MMDC_P1_BASE + 0x810, 0x00060015);
#endif
	out32(MX6X_MMDC_P0_BASE + 0x8b8, 0x00000800);
	out32(MX6X_MMDC_P1_BASE + 0x8b8, 0x00000800);
	out32(MX6X_MMDC_P0_BASE + 0x01c, 0x00000000);
	out32(MX6X_MMDC_P0_BASE + 0x404, 0x00011006);
#endif
#if defined (VARIANT_enableTZASC)
	out32(MX6X_MMDC_P0_BASE + 0x400, 0x114201f0);
#endif
}
