/*
 * $QNXLicenseC:
 * Copyright 2014, QNX Software Systems.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"). You
 * may not reproduce, modify or distribute this software except in
 * compliance with the License. You may obtain a copy of the License
 * at: http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as
 * contributors under the License or as licensors under other terms.
 * Please review this entire file for other proprietary rights or license
 * notices, as well as the QNX Development Suite License Guide at
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */

#ifndef _IPL_MX6X_H
#define _IPL_MX6X_H

#include <arm/mx6x.h>

/* Uncomment the line below to enable SOM2 support */
/* #define NITROGEN6_SOM2 */

/*
 * Make sure to set the RAM size that matches your platform:
 * - 1024 for 1GB of RAM
 * - 2048 for 2GB of RAM
 * - 3840 for 4GB of RAM
 */
#define MX6X_SDRAM_SIZE		1024

#define LE_2_BE_32(l) \
    ((((l) & 0x000000FF) << 24) | \
	(((l) & 0x0000FF00) << 8)  | \
	(((l) & 0x00FF0000) >> 8)  | \
	(((l) & 0xFF000000) >> 24))

#define	IVT_OFFSET             0x400

#define MXC_CONSOLE_BASE       MX6X_UART2_BASE

#endif
